package WebFlow.submitJob;

import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
import java.io.*; 

public class submitJobImpl extends WebFlow.BeanContextChildSupport 
                         implements submitJobOperations {

  String msg_ ; 
  org.omg.CORBA.Object peer ;

  private String user="webflow";
  private String thisHost="osprey4.npac.syr.edu";
  private String nextLine;

  public submitJobImpl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException {

  super(peer);
  this.peer = peer;
  String msg_ = msg;
 }

  public void test() {
        System.out.println("submitJob is up");
  }


  public void submit(WebFlow.submitJob.CmdLineEvent event) {
    String Host = event.getHost();
    String Rsl = event.getRsl();
    String CmdLine = event.getCmdLine();
    String User = event.getUser();
    User="webflow";

  System.out.println("submit called: "+Host+" "+CmdLine);  

    if(Rsl.startsWith("&")) {
       submitGlobus(Host,Rsl,User);
    }
    else {
      if(Host.indexOf(thisHost)>-1) {
       submitLocally(CmdLine);
      }
      else {
       submitRsh(Host,User,CmdLine);
      }
    } 

  }

  public void submitLocally(String CommandLine) {
  System.out.println("submitLocally: "+CommandLine);
   InputStream is; 

   try {
     Process p = Runtime.getRuntime().exec(CommandLine);
     is = p.getInputStream();
     InputStreamReader isr = new InputStreamReader(is);
     BufferedReader in = new BufferedReader(isr);
     while ((nextLine=in.readLine()) != null){
       System.out.println(nextLine);
     }
/*
     String nextLine = in.readLine();
     if(nextLine==null)
     System.out.println("this application does not write to stdout");
     else
     System.out.println(nextLine);
*/
     in.close();

     //   p.waitFor();        
    } 
     catch (Exception ex) {
     System.err.println("Error in starting the job :"+CommandLine);
     System.err.println(ex);
    }
   }

  public void submitRsh(String host, String user, String CommandLine) {
    CommandLine = "rsh -l "+user+" "+host+" "+CommandLine;
    submitLocally(CommandLine);
  }

  public void submitGlobus(String GramKeeper, String RSL, String user) {
    String CommandLine = "/npac/home/globus/globus_1.0/tools/sparc-sun-solaris2.5.1/bin/globusrun";
    CommandLine += " -r "+GramKeeper+" "+RSL;
    submitLocally(CommandLine);
  }    

  public void exportFile(String src, String dest, String remotehost,
                         String user){
    String cmdLine="rcp -p "+src+" "+user+"@"+remotehost+":"+dest;
    System.out.println(cmdLine);
    try {
        Process p =Runtime.getRuntime().exec(cmdLine);
        p.waitFor();
    }
    catch (Exception ex) {
     System.err.println("Error while rcp files :"+cmdLine);
     System.err.println(ex);
    }    
  }

  public void importFile(String src, String dest, String remotehost, 
                         String user){

    String cmdLine="rcp -p "+user+"@"+remotehost+":"+src+" "+dest;
    System.out.println(cmdLine);
    try {
        Process p =Runtime.getRuntime().exec(cmdLine);
        p.waitFor();
    }
    catch (Exception ex) {
     System.err.println("Error while rcp files :"+cmdLine);
     System.err.println(ex);
    }    
  }

}







